## libpg-query 17-6.0.0

=== debian/changelog ===
libpg-query (17-6.0.0-1.pgdg25.04+1) plucky-pgdg; urgency=medium

  * Rebuild for plucky-pgdg.
  * No source changes.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Tue, 10 Dec 2024 12:31:00 +0100

libpg-query (17-6.0.0-1) unstable; urgency=medium

  [ Bradford D. Boyle ]
  * New upstream version 17-6.0.0.
  * Bump soname to libpg-query1706.0.

  [ Christoph Berg ]
  * Drop t64 suffix from package name.

 -- Christoph Berg <myon@debian.org>  Tue, 10 Dec 2024 12:31:00 +0100

libpg-query (16-5.1.0-2.1) experimental; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.

 -- Steve Langasek <vorlon@debian.org>  Thu, 01 Feb 2024 23:08:07 +0000
