## libpg-query 17-6.1.0

=== debian/changelog ===
libpg-query (17-6.1.0-1) unstable; urgency=medium

  * New upstream version 17-6.1.0.

 -- Christoph Berg <myon@debian.org>  Thu, 03 Apr 2025 11:40:21 +0200
