## libpg-query 17-6.2.0

=== debian/changelog ===
libpg-query (17-6.2.0-2.pgdg25.10+1) questing-pgdg; urgency=medium

  * Rebuild for questing-pgdg.
  * No source changes.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Mon, 15 Dec 2025 10:46:04 +0100

libpg-query (17-6.2.0-2) unstable; urgency=medium

  * Install postgres_deparse.h.

 -- Christoph Berg <myon@debian.org>  Mon, 15 Dec 2025 10:46:04 +0100

libpg-query (17-6.2.0-1) unstable; urgency=medium

  * New upstream version 17-6.2.0.

 -- Christoph Berg <myon@debian.org>  Fri, 12 Dec 2025 15:39:14 +0100
