## libpg-query 17-6.2.1

=== debian/changelog ===
libpg-query (17-6.2.1-1) unstable; urgency=medium

  * New upstream version 17-6.2.1.

 -- Christoph Berg <myon@debian.org>  Wed, 21 Jan 2026 20:28:33 +0100
