## libpg-query 17-6.2.2

=== debian/changelog ===
libpg-query (17-6.2.2-1) unstable; urgency=medium

  * New upstream version 17-6.2.2.

 -- Christoph Berg <myon@debian.org>  Tue, 27 Jan 2026 16:03:34 +0100
